Layer (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.pqc.crypto.rainbow

## Class Layer

- java.lang.Object
- - org.bouncycastle.pqc.crypto.rainbow.Layer

-     public class Layer
      extends java.lang.Object

  This class represents a layer of the Rainbow Oil- and Vinegar Map. Each Layer consists of oi polynomials with their coefficients, generated at random.

  To sign a document, we solve a LES (linear equation system) for each layer in order to find the oil variables of that layer and to be able to use the variables to compute the signature. This functionality is implemented in the RainbowSignature-class, by the aid of the private key.

  Each layer is a part of the private key.

  More information about the layer can be found in the paper of Jintai Ding, Dieter Schmidt: Rainbow, a New Multivariable Polynomial Signature Scheme. ACNS 2005: 164-175 (http://dx.doi.org/10.1007/11496137_12)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Layer(byte vi, byte viNext, short[][][] coeffAlpha, short[][][] coeffBeta, short[][] coeffGamma, short[] coeffEta)` Constructor
    `Layer(int vi, int viNext, java.security.SecureRandom sr)` This function generates the coefficients of all polynomials in this layer at random using random generator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object other)` This function compares this Layer with another object.
    `short[][][]` | `getCoeffAlpha()` Getter for the alpha-coefficients of the polynomials in this layer.
    `short[][][]` | `getCoeffBeta()` Getter for the beta-coefficients of the polynomials in this layer.
    `short[]` | `getCoeffEta()` Getter for the eta-coefficients of the polynomials in this layer.
    `short[][]` | `getCoeffGamma()` Getter for the gamma-coefficients of the polynomials in this layer.
    `int` | `getOi()` Getter for the number of Oil variables of this layer.
    `int` | `getVi()` Getter for the number of vinegar variables of this layer.
    `int` | `getViNext()` Getter for the number of vinegar variables of the next layer.
    `int` | `hashCode()`
    `short[][]` | `plugInVinegars(short[] x)` This method plugs in the vinegar variables into the polynomials of this layer and computes the coefficients of the Oil-variables as well as the free coefficient in each polynomial.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Layer

          public Layer(byte vi,
               byte viNext,
               short[][][] coeffAlpha,
               short[][][] coeffBeta,
               short[][] coeffGamma,
               short[] coeffEta)

      Constructor
      Parameters:
        `vi` - number of vinegar variables of this layer
        `viNext` - number of vinegar variables of next layer. It's the same as (num of oils) + (num of vinegars) of this layer.
        `coeffAlpha` - alpha-coefficients in the polynomials of this layer
        `coeffBeta` - beta-coefficients in the polynomials of this layer
        `coeffGamma` - gamma-coefficients in the polynomials of this layer
        `coeffEta` - eta-coefficients in the polynomials of this layer

    - #### Layer

          public Layer(int vi,
               int viNext,
               java.security.SecureRandom sr)

      This function generates the coefficients of all polynomials in this layer at random using random generator.
      Parameters:
        `sr` - the random generator which is to be used

  - ### Method Detail

    - #### plugInVinegars

          public short[][] plugInVinegars(short[] x)

      This method plugs in the vinegar variables into the polynomials of this layer and computes the coefficients of the Oil-variables as well as the free coefficient in each polynomial.

      It is needed for computing the Oil variables while signing.

      Parameters:
        `x` - vinegar variables of this layer that should be plugged into the polynomials.
      Returns:
        coeff the coefficients of Oil variables and the free coeff in the polynomials of this layer.

    - #### getVi

          public int getVi()

      Getter for the number of vinegar variables of this layer.
      Returns:
        the number of vinegar variables of this layer.

    - #### getViNext

          public int getViNext()

      Getter for the number of vinegar variables of the next layer.
      Returns:
        the number of vinegar variables of the next layer.

    - #### getOi

          public int getOi()

      Getter for the number of Oil variables of this layer.
      Returns:
        the number of oil variables of this layer.

    - #### getCoeffAlpha

          public short[][][] getCoeffAlpha()

      Getter for the alpha-coefficients of the polynomials in this layer.
      Returns:
        the coefficients of alpha-terms of this layer.

    - #### getCoeffBeta

          public short[][][] getCoeffBeta()

      Getter for the beta-coefficients of the polynomials in this layer.
      Returns:
        the coefficients of beta-terms of this layer.

    - #### getCoeffGamma

          public short[][] getCoeffGamma()

      Getter for the gamma-coefficients of the polynomials in this layer.
      Returns:
        the coefficients of gamma-terms of this layer

    - #### getCoeffEta

          public short[] getCoeffEta()

      Getter for the eta-coefficients of the polynomials in this layer.
      Returns:
        the coefficients eta of this layer

    - #### equals

          public boolean equals(java.lang.Object other)

      This function compares this Layer with another object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the other object
      Returns:
        the result of the comparison

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`